#include <stdio.h>
#include "Fl_Bool_Output.h"
#include <FL/Fl_Shared_Image.H>
#include "igs.h"

static Fl_Shared_Image *ok_image, *cancel_image;

void Fl_Bool_Output::draw()
{
  draw_box();
  if (!ok_image) {
    ok_image = Fl_XPM_Image::get("images/stock_button_apply.xpm");
    cancel_image = Fl_XPM_Image::get("images/stock_button_cancel.xpm");
  }
  if (value_) {
    int W, H;
    ok_image->measure(W, H);
    ok_image->draw(x(), y(), w(), h(), -+(w()-W)/2, -(h()-H)/2);
  } else {
    int W, H;
    cancel_image->measure(W, H);
    cancel_image->draw(x(), y(), w(), h(), -+(w()-W)/2, -(h()-H)/2);
  }
}

int Fl_Bool_Output::handle(int event)
{
  switch (event) {
/*  case FL_ENTER:
  case FL_LEAVE:*/
  case FL_PUSH:
    return 1;
  case FL_RELEASE:
    value(!value_);
    char s[128];
    sprintf(s, "toggle %s %s", name, value_? "true":"false");
    igs->send(s);
    return 1;
  default:
    return Fl_Box::handle(event);
  }
}
