#include <FL/Fl.H>
#include <FL/fl_draw.H>
#include <FL/x.H>
#include <FL/Fl_Shared_Image.H>
#include <stdlib.h>
#include <stdio.h>
#include "Fl_RGBM_Image.h"

#ifdef WIN32
typedef unsigned int uint;
typedef unsigned long ulong;
#endif


int Fl_RGBM_Image::test(unsigned char *datas, size_t size)
{
  return 1;
}

void Fl_RGBM_Image::measure(int  &W, int &H)
{
  if (w>=0) { 
    W=w; H=h; 
    return; 
  }

  uint* dats = (uint*) datas;
  w = dats[0]; h = dats[1];
  W=w;
  H=h;
  //  printf("%d %d\n", w, h); fflush(stdout);
}

void Fl_RGBM_Image::read()
{
  id = mask = 0;

  uint* dats = (uint*) datas;
  w = dats[0];
  h = dats[1];
  //  printf("%d %d\n", w, h); fflush(stdout);

#ifdef WIN32
  id = (HBITMAP)fl_create_offscreen(w, h);
#else
  id = (ulong)fl_create_offscreen(w, h);
#endif
  fl_begin_offscreen(id);
  fl_draw_image(datas+8, 0, 0, w, h, 4);

  uchar *bitmap = (uchar*) malloc((w+7)/8*h), *inib = bitmap;
  int W = (w+7)/8;
  for (int y = 0; y < h; y++) {
    const uint* p = dats+2+y*w;
    for (int x = 0; x < W; x++) {
      int b = 0;
      for (int i = 0; i < 8; i++) {
	if (*p++ < 0x1000000) b |= (1<<i);
      }
      *bitmap++ = b;
    }
  }
#ifdef WIN32
  mask = (HBITMAP) fl_create_bitmap(inib, w, h);
#else
  mask = (ulong) fl_create_bitmap(inib, w, h);
#endif
  free(inib);
  fl_end_offscreen();
}

