#include "connection.h"
#include <stdio.h>
extern "C" { 
#include <winsock.h>
#include <windows.h>
}

typedef unsigned short uint16_t;

static bool init_sockaddr (struct sockaddr_in *name,
			   const char *hostname,
			   uint16_t port)
{
  struct hostent *hostinfo;
  
  name->sin_family = AF_INET;
  name->sin_port = htons (port);
  hostinfo = gethostbyname (hostname);
  if (hostinfo == NULL) {
    fprintf (stderr, "Unknown host %s\n", hostname);
    return 0;
  }
  name->sin_addr = *(struct in_addr *) hostinfo->h_addr;
  return 1;
}

Connection::Connection()
{
  sock = fdin = fdout = -1;
}


Connection::~Connection()
{
  close();
}


bool Connection::open( char*s, int p )
{
  static int init = 0;
  if (!init) {
    WSADATA data;
    
    if (WSAStartup(0x0101, &data)) {
      fprintf(stderr, "Cannot initialize socket DLL !\n");
      return 0;
    }
    init = 1;
  }

  sockaddr_in name;

//  sock = socket(AF_INET, SOCK_STREAM, PF_UNSPEC);
  sock = socket(2,1,6);
  if (sock == INVALID_SOCKET) {
    fprintf(stderr, "Cannot create socket !\n");
    return 0;
  }

  if (!init_sockaddr (&name, s, p)) return 0;

  if (0 > connect(sock, (sockaddr*) &name, sizeof(name))) {
    perror("Connection::open");
    close();
    return 0;
  }

/*  if (ioctlsocket(sock, F_SETFL, O_NONBLOCK) == -1) {
    fprintf(stderr, "WARNING : Could not execute fcntl on socket");
    //    return 0;
  }*/
  unsigned long coucou = 1;
  if (ioctlsocket(sock, FIONBIO, 0) == SOCKET_ERROR) {
    fprintf(stderr, "WARNING : Could not execute ioctl on socket");
    //    return 0;
  }
  printf("coucou = %x\n", coucou);

  fdin = sock;
  fdout = sock;

  fprintf(stderr, "Connection succeded !\n");
  
  return 1;
}

void Connection::close()
{
  if (sock > 0)
    printf("closesocket returns %d\n", ::closesocket(sock));
  sock = 0;
}

int Connection::read(void* buf, int sz)
{
  return recv(fdin, (char*)buf, sz, 0);
}

int Connection::write(const void* buf, int sz)
{
  return send(fdout, (const char*)buf, sz, 0);
}

