#ifndef GAMEBROWSER_H
#define GAMEBROWSER_H

#include <FL/Fl_Browser.H>
#include "igsgame.h"

class GameBrowser : public Fl_Browser {

 private:

  class Widget : public Fl_Widget {
  public:
    Widget();
    ~Widget();
    void draw();
    int handle(int event);
    int n;
    GameBrowser* b;
  };

  friend class GameBrowser::Widget;

  Widget widget;

  class List : public Fl_List {
  public:
    virtual int children(const Fl_Menu_*, const int* indexes, int level);
    virtual Fl_Widget* child(const Fl_Menu_*, const int* indexes, int level);
    GameBrowser* b;
  };

  friend class GameBrowser::List;

  List my_list;

 public:

  int games[MAX_IGSGAMES];

  int nbgames;

  GameBrowser(int x, int y, int w, int h, char* l = 0);
  ~GameBrowser();
  
  void sort();
  void click(); // click callback
  
};

#endif // ifdef GAMEBROWSER_H
