//
//                   **** ViZiGO (C) 2000 Vincent Penne ****
// This software if distributed under the GPL license (See the file LICENSE
// that must be included with this source)
//
/** 
 *  @file moves_browser.h
 *
 * MovesBrowser class definition
 *
 */

#ifndef MOVEBROWSER_H
#define MOVEBROWSER_H

#include <FL/Fl_Browser.H>
#include <FL/Fl_Tabs.H>
#include "story.h"

class Board;

/**
 * class MovesBrowser
 */
class MovesBrowser : public Fl_Browser {
 private:

  /**
   * The widget used to draw one move
   */
  class Widget : public Fl_Widget {
  public:
    Widget();
    ~Widget();
    void draw();
    int handle(int event);
//    Board* board;
    MovesBrowser* b;
    int n;
  };
  friend class MovesBrowser::Widget;
  Widget widget;         ///< one widget for all moves

  /**
   * The list used by the Fl_Browser
   */
  class List : public Fl_List {
  public:
    virtual int children(const Fl_Menu_*, const int* indexes, int level);
    virtual Fl_Widget* child(const Fl_Menu_*, const int* indexes, int level);
    MovesBrowser* b;
  };
  friend class MovesBrowser::List;
  List my_list;          ///< instance of the list
  int max_indent; ///< maximum indentation

 public:

  Board* board; ///< board
  Story** moves;
  Story** sel_moves;
  int nbmoves, maxmoves;

  MovesBrowser(int x, int y, int w, int h, char* l = 0);
  ~MovesBrowser();

  int handle(int event);

  void graph(int n, Story* s); ///< prepare the graph
  void make_graph(); ///< prepare the graph
};

class Fl_Tabs_NF : public Fl_Tabs {
 public:
  Fl_Tabs_NF(int x, int y, int w, int h, char* l=0) : Fl_Tabs(x,y,w,h, l) {}
  ~Fl_Tabs_NF() {}

  int handle(int e);
};


class Fl_Group_NF : public Fl_Group {
 public:
  Fl_Group_NF(int x, int y, int w, int h, char* l=0) : Fl_Group(x,y,w,h, l) {}
  ~Fl_Group_NF() {}

  int handle(int e);
};

#endif // ifdef MOVEBROWSER_H
