//
//                   **** ViZiGO (C) 2000 Vincent Penne ****
// This software if distributed under the GPL license (See the file LICENSE
// that must be included with this source)
//
/** 
 *  @file observer_browser.h
 *
 * ObserverBrowser class definition
 *
 */

#ifndef OBSERVERBROWSER_H
#define OBSERVERBROWSER_H

#include <FL/Fl_Browser.H>
#include "igsplayer.h"

/**
 * class ObserverBrowser
 */
class ObserverBrowser : public Fl_Browser {
 private:

  /**
   * The widget used to draw one observer
   */
  class Widget : public Fl_Widget {
  public:
    Widget();
    ~Widget();
    void draw();
    int handle(int event);
    char* name;
    ObserverBrowser* b;
  };
  friend class ObserverBrowser::Widget;
  Widget widget;         ///< one widget for all observers

  /**
   * The list used by the Fl_Browser
   */
  class List : public Fl_List {
  public:
    virtual int children(const Fl_Menu_*, const int* indexes, int level);
    virtual Fl_Widget* child(const Fl_Menu_*, const int* indexes, int level);
    ObserverBrowser* b;
  };
  friend class ObserverBrowser::List;
  List my_list;          ///< instance of the list

 public:

  char** observers;
  int nbobservers;
  int maxobservers;

  ObserverBrowser(int x, int y, int w, int h, char* l = 0);
  ~ObserverBrowser();
  
  void clear();          ///< clear observer list
  void add(const char* name); ///< add an observer
  
};

#endif // ifdef OBSERVERBROWSER_H
