#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "options.h"
#include "debug.h"


// is it a symbol ?
static bool is(char c)
{
  switch(c) {
  case '(': case ')': case '[': case ']': case ';': case 10 : case 13:
    //  case ')': case ')': case ')': case ')': case ')': case ')': case ')':
    return 1;

  default:
    return 0;
  };
}

static char *p, *buffer, *end;

static char* getword()
{
  static char s[10*1024];
  while (p<end && isspace(*p)) p++;
  if (p>=end) return "";
  if (is(*p)) {
    *s = *p;
    s[1] = 0;
    p++;
    //    DBGprintf("<<%s>>", s); fflush(stdout);
    return s;
  }
  char *ps = s;
  while (p<end && !is(*p) && !isspace(*p)) *ps++ = *p++;
  *ps++ = 0;
  //  DBGprintf("<%s>", s); fflush(stdout);
  return s;
}

static char* getbracket(bool a=0)
{
  static char s[10*1024];
  int num = 1;
  *s = 0;
  char* w;
  if (!a) {
    w = getword();
    if (*w != '[') {DBGprintf("no bracket !! %s\n", w); return "";}
  }
  do {
    //    w = getword();
    if (*p == ']') num--;
    if (*p == '[') num++;
    if (num>0) { char w[2]; w[0]=*p; w[1] = 0; strcat(s, w); }
    p++;
  } while (num>0 && p<end);
  //  DBGprintf("[%s]", s); fflush(stdout);
  return s;
}

Options::Options()
{
  user = password = 0;
  server = strdup("");
  clear();
}

Options::~Options()
{
  clear();
  free(server);
}

void Options::clear()
{
  if (user) {
    free(user);
    user = 0;
  }
  if (password) {
    free(password);
    password = 0;
  }
  if (server) {
    free(server);
    server = strdup("igs.joyjoy.net");
  }
  server_port = 6969;
}

void Options::read(const char* name)
{
  if (!name) return;

  clear();

  FILE* fp = fopen(name, "r");
  if (!fp) return;
  buffer = (char*) malloc(10*1024);
  end = buffer+fread(buffer, 1, 10*1024, fp);
  fclose(fp);
  
  char* s;
  for (p = buffer, s = getword(); p < end; s = getword()) {
    if (!strcmp(s, "user")) {
      if (user) free(user);
      user = strdup(getword());
    } else if (!strcmp(s, "password")) {
      if (password) free(password);
      password = strdup(getword());
    } else if (*s == '#') {
      while (p<end && *p != '\n') p++;
    } else if (!strcmp(s, "server")) {
      free(server);
      server = strdup(getbracket());
      server_port = atoi(getword());
    } /*else break; /*if (p<end)
      fprintf(stderr, "Bad option file (unknown token '%s') !\n", s);*/
  }  

  free(buffer);
}
