class ResultsBrowser;
#include "player_browser.h"
#include "vizigo.h"
#include <FL/fl_draw.H>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "stone.h"
#include "igs.h"

#define stn small_stone

ResultsBrowser::ResultsBrowser(int x, int y, int w, int h, char* l) : 
  Fl_Browser(x,y,w,h,l)

{
  player = 0;
  my_list.b = this;
  widget.b = this;
  list(&my_list);
  parent()->remove(widget); // Yuck ! This is a problem because FLTK's 
                            // automatic add to groups feature !!
  type(type()|VERTICAL);
  widget.resize(0, 0, w-20, 13);
}

ResultsBrowser::~ResultsBrowser()
{
}

int ResultsBrowser::List::children(const Fl_Menu_*, const int* indexes, int level)
{
  if (level || !b->player) return 0;
  return b->player->nbresults;
}

Fl_Widget* ResultsBrowser::List::child(const Fl_Menu_*, const int* indexes, int level)
{
  if (level || !b->player) return 0;
  if (*indexes < 0 || *indexes >= b->player->nbresults) return 0;
  b->widget.r = b->player->results + *indexes;
  b->widget.clear_flag(FL_VALUE);
  return &b->widget;
}

#define W 600-20
#define H 13
ResultsBrowser::Widget::Widget() : Fl_Widget(0, 0, W, H, 0)
{
}

ResultsBrowser::Widget::~Widget()
{
}

void ResultsBrowser::Widget::draw()
{
  int x = this->x(), y = this->y(), w = this->w(), h = this->h();
  gigs(b);
#ifdef WIN32
  fl_font(FIXED_FONT, FIXED_FONTSIZE-2);
#else
  fl_font(b->text_font(), b->text_size()-2);
#endif
  fl_color(b->text_color());
  char s[128];
  sprintf(s, "%15s [%3s] %15s [%3s]  %2d %2.1f %2d  %9s %10s %c", 
	  r->winner, r->winner_rank, r->loser, r->loser_rank,
	  r->handi, r->komi, r->size, r->result, r->date, 
	  b->player->igs->nngs? ' ' : (r->rated? 'R':'F'));
  fl_draw(s, x, y, w, h, FL_ALIGN_LEFT);
  stn->draw(x+6, y, *r->result == 'W' ? 1 : 0);
  stn->draw(x+11*12+6, y, *r->result == 'B' ? 1 : 0);
}

int ResultsBrowser::Widget::handle(int event) {
  return 0;
}


