//
//                   **** ViZiGO (C) 2000 Vincent Penne ****
// This software if distributed under the GPL license (See the file LICENSE
// that must be included with this source)
//
/** 
 *  @file results_browser.h
 *
 * ResultsBrowser class definition
 *
 */

#ifndef RESULTBROWSER_H
#define RESULTBROWSER_H

#include <FL/Fl_Browser.H>
#include "igsplayer.h"

/**
 * class ResultsBrowser
 */
class ResultsBrowser : public Fl_Browser {
 private:

  /**
   * The widget used to draw one result
   */
  class Widget : public Fl_Widget {
  public:
    Widget();
    ~Widget();
    void draw();
    int handle(int event);
    IgsPlayerResult* r;
    ResultsBrowser* b;
  };
  friend class ResultsBrowser::Widget;
  Widget widget;         ///< one widget for all results

  /**
   * The list used by the Fl_Browser
   */
  class List : public Fl_List {
  public:
    virtual int children(const Fl_Menu_*, const int* indexes, int level);
    virtual Fl_Widget* child(const Fl_Menu_*, const int* indexes, int level);
    ResultsBrowser* b;
  };
  friend class ResultsBrowser::List;
  List my_list;          ///< instance of the list

 public:

  IgsPlayer* player; ///< selected player

  ResultsBrowser(int x, int y, int w, int h, char* l = 0);
  ~ResultsBrowser();

  //int handle(int event);
};

#endif // ifdef RESULTBROWSER_H
