
#include "defs.h"

#ifdef CKM_STORED
class StoredBrowser;

#include "igsplayer.h"
#include "stored_browser.h"
#include <FL/fl_draw.H>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "vizigo.h"
#include "igs.h"
// static Stone* stn;

int StoredBrowser::List::children(const Fl_Menu_*, const int* indexes, int level)
{
  if (level) return 0;
  return b->nbstored;
}


Fl_Widget* StoredBrowser::List::child(const Fl_Menu_*, const int* indexes, int level)
{
	int n = *indexes;	
	if (level || !b->player || n < 0 || n >= b->nbstored)
		return 0;

	b->widget.n = n;
	return &b->widget;
}


#define W 650-20
#define H 13
StoredBrowser::Widget::Widget() : 
  Fl_Widget(0, 0, W, H, 0)
{
}

StoredBrowser::Widget::~Widget()
{
}

void StoredBrowser::Widget::draw()
{
  
	char *s = b->find( this->n );

	if ( !s )
		s = "";

	int x = this->x(), y = this->y(), w = this->w(), h = this->h();

#ifdef WIN32
	fl_font(FIXED_FONT, FIXED_FONTSIZE);
#else
	fl_font(b->text_font(), b->text_size());
#endif
	fl_color(b->text_color());
 
	fl_draw( s, x, y, w, h, FL_ALIGN_LEFT);
}


int StoredBrowser::Widget::handle(int event) {

/*	switch (event) {
		case FL_PUSH:
		case FL_DRAG:
		case FL_KEYBOARD:
			return 1;

	}
*/
	return 0;
}


void StoredBrowser::click()
{

	gigs(this);
	cur_igs->UI->look( value() );
}


StoredBrowser::StoredBrowser(int x, int y, int w, int h, char* l) : 
  Fl_Browser(x,y,w,h,l)

{
	stored = NULL;
	nbstored = 0;
	my_list.b = this;
	widget.b = this;
	list(&my_list);
	parent()->remove(widget); // Yuck ! This is a problem because FLTK's 
		                        // automatic add to groups feature !!
	type(type()|VERTICAL_ALWAYS);
	player = NULL;
}

StoredBrowser::~StoredBrowser()
{
}


void StoredBrowser::init_player( IgsPlayer *p )
{
	if ( p )
	{
		player = p;
		nbstored = p->nbstored;
		stored = p->stored_buf;
		layout();
	}

}

char * StoredBrowser::find( int i )
{

	char *s = stored;

	if ( s )
	{
		while( i && *s )
		{
			s += strlen(s) + 1;
			i--;
		}

		return s;
	}

	return NULL;
}

#endif
